; Reporte de errores y/o sugerencias a: "Guillermo Senna" <gsenna@gmail.com> // Año: 2016

<Cabbage>
form caption("Electronica Fija"), size(1024,570)

groupbox bounds(12, 6, 614, 543), identchannel("grbox"), text("Oscillators 1 - 8")
numberbox bounds(556, 504, 50, 36), widgetarray("fq", 8), range(20, 20000, , 1, 0.01)
numberbox bounds(610, 504, 50, 36), widgetarray("st", 8), range(0, 3600, , 1, 0.01)  
numberbox bounds(124, 205, 50, 33), widgetarray("du", 8), range(0, 3600, , 1, 0.01)
numberbox bounds(718, 504, 50, 36), widgetarray("am", 8), range(0, 100, , 1, 0.1)
combobox bounds(772, 512, 38, 19), widgetarray("chn", 8), items("S", "L", "R")
combobox bounds(812, 512, 77, 20), widgetarray("wf", 8), items("Sine", "Saw", "Square", "Triangle", "Pulse")

texteditor bounds(358, 90, 200, 18), widgetarray("env", 8)

button bounds(476, 88, 52, 30), widgetarray("applyEnv", 8), text("Draw", "Draw")

label bounds(22, 46, 51, 20), text("Fq")
label bounds(70, 46, 51, 20), text("St")
label bounds(124, 46, 51, 20), text("Dur")
label bounds(176, 46, 51, 20), text("Amp")
label bounds(228, 46, 51, 20), text("Chn")
label bounds(286, 46, 51, 20), text("Wf")
label bounds(412, 46, 100, 20), text("Envelope")


groupbox bounds(632, 8, 386, 137), text("Controls")
button bounds(772, 92, 140, 37), channel("btn1"), text("Start", "Stop")
checkbox bounds(660, 92, 98, 36), channel("r_check"), text("Rec")  

checkbox  bounds(996, 80, 18, 17),  channel("Overload"),text("Overload"), colour(255, 60, 60), textcolour("white") shape("Ellipse")
rslider   bounds(920, 48, 70, 79),  channel("Level"),text("Level"), colour( 20, 60, 70), trackercolour(200,240,250), textcolour("white"), range(0, 1, 0.36,0.5,0.001)

gentable bounds(632, 148, 190, 192), channel("pos","end"), tablecolour("yellow"), identchannel("table1"), scrubberposition(0, 0), startpos(-1), outlinethickness("2"), tablebackgroundcolour(79, 135, 78, 32), tablegridcolour(82, 233, 82, 15), tableconfig(212),  tablenumber(212), amprange(-0.0099999997764825820923,1.0399999618530273438,212,0.10000000149011611938), 
gentable bounds(828, 148, 190, 192), channel("pos1","end1"), tablecolour("red"), identchannel("table2"), scrubberposition(0, 0), outlinethickness(2), tablebackgroundcolour(22, 142, 4, 0), tablegridcolour(0, 250, 222, 9), tableconfig(213),  tablenumber(213), amprange(-1.1000000238418579102,1.1000000238418579102,213,0.0010000000474974513054), 


fftdisplay bounds(632, 343, 386, 179), colour("cornflowerblue"), identchannel("fft")
button bounds(632, 524, 387, 26), channel("displaytype"), text("Spectroscope", "Spectrogram")

combobox bounds(652, 48, 154, 29), channel("combobox"), populate("*.snaps", "Presets")
filebutton bounds(820, 48, 89, 35), channel("but1"), text("Save"), populate("*.snaps", "Presets")

</Cabbage>

<CsoundSynthesizer>


<CsOptions>
--displays -n 
</CsOptions>

<CsInstruments>

sr 		= 	44100	
ksmps 		= 	32	
nchnls 		= 	2	
0dbfs		=	1

giMaxdur init 0 ; Duration of the osc. that lasts longer
gaL init 0      ; Global variable for left audio channel
gaR init 0      ; Global variable for right audio channel
giEnv ftgen   212, 0, 100, -2, 50 ; Table that holds the envelope
giWf ftgen   213, 0, 16383, -2, 50 ; Table that holds the waveform


giSaw_A ftgen 22, 0, 16383, 10, 1, 1/2, 1/3, 1/4, 1/5, 1/6, 1/7, 1/8,\ ; Table with Saw wave
                                                1/9, 1/10, 1/11, 1/12, 1/13, 1/14,\
                                                1/15, 1/16, 1/17, 1/18, 1/19, 1/20

giSquare_A ftgen 23, 0, 16383, 10, 1, 0, 1/3, 0, 1/5, 0, 1/7, 0, 1/9,\ ; Table with Square wave
                                                0, 1/11, 0, 1/13, 0, 1/15, 0, \
                                                1/17, 0, 1/19


giTriangle_A ftgen 24, 0, 16383, 9, 1, 1, 0, \ ; Table with Triangle wave
                                                3, 1/(3*3), 180, \
                                                5, 1/(5*5), 0, \
                                                7, 1/(7*7), 180, \
                                                9, 1/(9*9), 0, \
                                                11, 1/(11*11), 180, \
                                                13, 1/(13*13), 0, \
                                                15, 1/(15*15), 180, \
                                                17, 1/(17*17), 0, \
                                                19, 1/(19*19), 180 

; Returns the length of an array-string
#include "inc/StrayLen.csd"
; Gets one number from a string-array
#include "inc/StrayGetNum.csd"

instr	1
; Reposition some elements in the form.
    iCnt init 1
	iRow init 82
	iCol init 16
	until iCnt > 8 do
		Sfq sprintfk "pos(%d, %d)", iCol, iRow
		Sst sprintfk "pos(%d, %d)", iCol+54, iRow
		Sdu sprintfk "pos(%d, %d)", iCol+108, iRow
		Sam sprintfk "pos(%d, %d)", iCol+162, iRow
		Schn sprintfk "pos(%d, %d)", iCol+216, iRow+6
		Swf sprintfk "pos(%d, %d)", iCol+258, iRow+6
		Senv sprintfk "pos(%d, %d)", iCol+342, iRow+8
		SappEnv sprintfk "pos(%d, %d)", iCol+550, iRow+4
		
		SchnFq sprintfk "fq_ident%d", iCnt
		SchnSt sprintfk "st_ident%d", iCnt
		SchnDu sprintfk "du_ident%d", iCnt
		SchnAm sprintfk "am_ident%d", iCnt
		SchnChn sprintfk "chn_ident%d", iCnt
		SchnWf sprintfk "wf_ident%d", iCnt
		SchnEnv sprintfk "env_ident%d", iCnt
		SchnAppEnv sprintfk "applyEnv_ident%d", iCnt
		
		chnset Sfq, SchnFq
		chnset Sst, SchnSt
		chnset Sdu, SchnDu
		chnset Sam, SchnAm
		chnset Schn, SchnChn
		chnset Swf, SchnWf
		chnset Senv, SchnEnv
		chnset SappEnv, SchnAppEnv
		
		iRow += 60
		iCnt=iCnt+1
	enduntil

; Call instr. 8 when we need to update the envelope.
#include "inc/changeTables.inc"

   clear gaL,gaR
   ; allows users to toggle the type of display
   kChangeDisplay chnget "displaytype"
   if changed:k(kChangeDisplay)==1 then
      if kChangeDisplay==1 then
	    chnset "displaytype(\"spectrogram\")", "fft"
	  else
	    chnset "displaytype(\"spectroscope\")", "fft"
	  endif
   endif
   	
   ; Start/Stop button.
   gkPlayStop chnget "btn1"
   if changed:k(gkPlayStop) == 1 then
      if gkPlayStop == 0 then
    		gaL = 0
    		gaR = 0
       	   event "i", 102, 0, 0.1
      else
			event "i", 2, 0, -1
 	  endif
   endif

endin

instr 8
		Senv chnget sprintf("env%d", p4) ; Get string from the envelope texteditor
		iComp strcmp Senv, ""            
		if iComp == 0 goto tOff          ; If string is null, end
		istrlen    strlen   Senv         ; Lenght of string
    	idelimiter strindex Senv, " "    ; Position of first delimiter
    	S1    strsub Senv, 0, idelimiter ; Type of envelope  
    	SenvPayload    strsub Senv, idelimiter + 1, istrlen ; Envelope 
		if strcmp(S1, "t") == 0 then
			Sfenv sprintf "f %d 0 100 -16 %s", p4+110, SenvPayload ; transeg
		elseif strcmp(S1, "e") == 0 then	
			Sfenv sprintf "f %d 0 100 -05 %s", p4+110, SenvPayload ; exponseg
		else
			Sfenv sprintf "f %d 0 100 -07 %s", p4+110, SenvPayload ; linseg
		endif
		scoreline_i Sfenv ; Create table
		event "i", 9, 0, -1, p4
		turnoff
		tOff:
endin

instr 9
 	tablecopy 212, 110+p4 ; Copy the envelope into reusable table 212
	SmsgEn		sprintf	"tablenumber(%d)", 212	
	chnset	SmsgEn,"table1" ; Update the envelope graph

 	SwfNo		sprintf	"wf%d", p4
	iWf chnget SwfNo
	
	tablecopy 213, 20+iWf ; Copy the waveform into reusable table 213
	SmsgWf		sprintf	"tablenumber(%d)", 213	
	chnset	SmsgWf,"table2" ; Update the waveform graph

   	turnoff
endin


instr 2 ; 'Start' was pressed
	if (gkPlayStop == 0) then
		turnoff
	endif

	krcheck chnget "r_check" ; is Rec active?
	if changed(krcheck) == 1 && krcheck == 1 then
		event "i", 101, 0, -1
	endif

	iCnt = 1
	until iCnt > 8 do
	    ; Read parameters from the form.
		iFq chnget sprintfk("fq%d", iCnt)
		iSt chnget sprintfk("st%d", iCnt)
		iDu chnget sprintfk("du%d", iCnt)
		iAmp chnget sprintfk("am%d", iCnt)
		giMaxdur = (iDu+iSt > giMaxdur ? iDu+iSt : giMaxdur) ; Is this the osc. that lasts longer?
		event_i "i", 3, 0, iDu+iSt, iFq, iAmp/100, iSt, iDu, iCnt
		iCnt += 1
	enduntil
	event_i "i", 5, 0, giMaxdur ; Activate the output and check Overload
	event_i "i", 100, 0, giMaxdur ; Release the Start button automatically.
	
 endin

instr 3
	if gkPlayStop == 0 then
		turnoff
	endif
	kTrigger init 0
	timout 0, p6, setkTrigger ; delay the start of the instrument until iSt.
	kTrigger = 1
	schedwhen kTrigger, 4, 0, p7, p4, p5, p8 ; call instr. 4
	setkTrigger:
	kTrigger = 0
endin

instr 4
	if gkPlayStop == 0 || p3 == 0  || p4 == 0 then
		turnoff
	endif
	
	kndx phasor 1/p3
	kEnvelope tablei kndx, 110+p6, 1 ; Read the envelope from the corresponding table.
	iWf chnget sprintf("wf%d", p6) ; Get the waveform.
	asig poscil kEnvelope*p5, p4, 20+iWf
	
	iChn chnget sprintf("chn%d", p6) ; Left, Right or Stereo?

	if iChn == 1 then
	  gaL += asig
	  gaR += asig
	elseif iChn == 2 then
  	  gaL += asig
	elseif iChn == 3 then
	  gaR += asig
	endif   
 

endin

instr 5
 kLevel chnget "Level"

;Code taken from an example made by Iain McCurdy 
 /* PREVENT OVERLOADS */
 kRMS_L	rms gaL*kLevel				; scan rms
 kRMS_R	rms	gaR*kLevel				; scan rms
 kOn	=	1				; on value (needs to be a k-rate var.)
 kOff	=	0				; off value (needs to be a k-rate var.)
 kOverload	chnget	"Overload"		; read in value of 'Overload' LED
 if kRMS_L>0.5 || kRMS_R>0.5 then				; if rms exceeds a given value...
  chnset	kOn,"Overload"			; turn on 'Overload' LED
 endif
; ----------------------
 
 outs gaL*kLevel, gaR*kLevel ; Write to the audio channels
 dispfft (gaL+gaR)*kLevel*0.5, .1, 2048 ; FFT

 clear  gaL, gaR ; Set every sample of each of the given audio signals to zero when it is performed

endin

instr 100 
	if release() == 1 then
		chnset k(0), "btn1" ; If we reached giMaxdur, release the Start button
	endif
endin

instr 101 ; Start recording
	aSigL,aSigR   monitor
	iDate date
	Sfile sprintfk "../Recordings/EF_%d.wav", iDate
	fout     Sfile,4,aSigL,aSigR   
endin

instr 102
	turnoff2 101, 0, 0.1
	turnoff2 100, 0, 0.1
	giMaxdur = 0
	dispfft gaL+gaR, .1, 2048
  
endin


</CsInstruments>

<CsScore>
f21 0 16383 10 1                                          ; Table with a Sine wave
f25 0 16383 10 1 1   1   1    0.7 0.5   0.3  0.1          ; Table with a pulse

i 1 0 [3600*24*7]
</CsScore>

</CsoundSynthesizer>
