; Reporte de errores y/o sugerencias a: "Guillermo Senna" <gsenna@gmail.com> // Año: 2016

<Cabbage>
form caption("Tiempo Real"), size(1024, 570)

groupbox bounds(10, 0, 563, 489), identchannel("grbox"), text("Oscillators 1 - 8")

numberbox bounds(556, 504, 50, 36), widgetarray("fq", 8), range(20, 20000, , 1, 0.01)
numberbox bounds(610, 504, 50, 36), widgetarray("am", 8), range(0, 100, , 1, 0.1)
combobox bounds(724, 512, 38, 19), widgetarray("chn", 8), items("S", "L", "R")
combobox bounds(800, 512, 77, 20), widgetarray("wf", 8), items("Sine", "Saw", "Square", "Triangle", "Pulse")

texteditor bounds(358, 90, 200, 18), widgetarray("env", 8)

button bounds(16, 52, 51, 20), widgetarray("applyEnv", 8), text("Draw", "Draw")

label bounds(16, 52, 51, 20), text("Fq")
label bounds(84, 52, 51, 20), text("Amp")
label bounds(152, 52, 51, 20), text("Chn")
label bounds(218, 52, 51, 20), text("Wf")
label bounds(340, 52, 102, 20), text("Envelope")


groupbox bounds(580, 0, 437, 116), text("Controls")

checkbox  bounds(968, 56, 18, 17),  channel("Overload"),text("Overload"), colour(255, 60, 60), textcolour("white") shape("Ellipse")
rslider   bounds(888, 32, 70, 79),  channel("Level"),text("Level"), colour( 20, 60, 70), trackercolour(200,240,250), textcolour("white"), range(0, 1, 0.36,0.5,0.001)


button bounds(700, 68, 175, 40), channel("btn1"), text("Rec", "Stop")
checkbox bounds(616, 68, 68, 40), channel("recOn"), colour(255, 60, 60), shape("Ellipse") 


gentable bounds(580, 120, 215, 159),  tablecolour("yellow"), identchannel("table1"), scrubberposition(0, 0), startpos(-1), outlinethickness(2), tablebackgroundcolour(79, 135, 78, 32), tablegridcolour(82, 233, 82, 15) ,  tablenumber(212), amprange(-0.0099999997764825820923,1.0399999618530273438,212,0.10000000149011611938), 
gentable bounds(798, 120, 218, 157), tablecolour("lime"), identchannel("table2"), outlinethickness(2), tablebackgroundcolour(22, 142, 4, 0), tablegridcolour(0, 250, 222, 9), tablenumber(213), amprange(-1.1000000238418579102,1.1000000238418579102,213,0.0010000000474974513054), 

fftdisplay bounds(580, 276, 436, 193), colour("cornflowerblue"), identchannel("fft")
button bounds(580, 468, 444, 23), channel("displaytype"), text("Spectroscope", "Spectrogram")

numberbox bounds(12, 492, 58, 62), widgetarray("fqOffset", 128), range(-99, 99, 0), visible(0)
button bounds(76, 492, 58, 62), channel("setTuning"), text("A4", ""),  identchannel("setTuning_ident"),  

combobox bounds(612, 32, 154, 29), channel("combobox"), populate("*.snaps", "Presets")
filebutton bounds(780, 32, 95, 29), channel("but1"), text("Save"), populate("*.snaps", "Presets")

keyboard bounds(140, 492, 875, 59), middlec("4"),  


</Cabbage>

<CsoundSynthesizer>

<CsOptions>
--displays -n -+rtmidi=null -M0 -Q0
</CsOptions>

<CsInstruments>

sr 		= 	44100	
ksmps 		= 	32	
nchnls 		= 	2	
0dbfs		=	1

gkPlaying [] init 128 ; Which notes are currently on?
giKey init 69 ; Midi note number of current key pressed
gkLastKey init 69 ; Midi note number of last key pressed
gSnotes[] fillarray "C", "C#", "D", "D#", "E", "F", "F#","G","G#", "A", "A#", "B" ; To form the text in the tuning button
gaL init 0 ; Global variable for left audio channel
gaR init 0 ; Global variable for right audio channel
giTotalDur[] init 17 ; Total duration of the envelope
giReleaseDur[] init 17 ; Duration of the release segment

giEnv ftgen   212, 0, 10000, -2, 50 ; Table that holds the envelope
giWf ftgen   213, 0, 16383, -2, 50 ; Table that holds the waveform


giSaw_A ftgen 22, 0, 16383, 10, 1, 1/2, 1/3, 1/4, 1/5, 1/6, 1/7, 1/8,\ ; Table with Saw wave
                                                1/9, 1/10, 1/11, 1/12, 1/13, 1/14,\
                                                1/15, 1/16, 1/17, 1/18, 1/19, 1/20

giSquare_A ftgen 23, 0, 16383, 10, 1, 0, 1/3, 0, 1/5, 0, 1/7, 0, 1/9,\ ; Table with Square wave
                                                0, 1/11, 0, 1/13, 0, 1/15, 0, \
                                                1/17, 0, 1/19


giTriangle_A ftgen 24, 0, 16383, 9, 1, 1, 0, \ ; Table with Triangle wave
                                                3, 1/(3*3), 180, \
                                                5, 1/(5*5), 0, \
                                                7, 1/(7*7), 180, \
                                                9, 1/(9*9), 0, \
                                                11, 1/(11*11), 180, \
                                                13, 1/(13*13), 0, \
                                                15, 1/(15*15), 180, \
                                                17, 1/(17*17), 0, \
                                                19, 1/(19*19), 180 

; Returns the length of an array-string
#include "inc/StrayLen.csd"
; Gets one number from a string-array
#include "inc/StrayGetNum.csd"
; Gets one element from a string-array
#include "inc/StrayGetEl.csd"



; Get total duration of the envelope string
opcode	getTotalDur,i, Si
 Spayload, iArgCnt xin
 
 iLen StrayLen Spayload
 iLen -= 1
 iCnt = 0
 iReturn init 0
 until iCnt > iLen do
 	iTmp StrayGetNum Spayload, iCnt
 	iReturn += ((iCnt%iArgCnt)==1? iTmp : 0)
  	iCnt += 1
 enduntil
 xout iReturn
endop

;Replace seconds in string with percentages*100
opcode	setPercentagesInString,S, iSi
 iNo,Spayload, iArgCnt xin
 
 iLen StrayLen Spayload
 iLen -= 1
 iCnt = 0
 Sreturn init ""
 until iCnt > iLen do
 	Stmp StrayGetEl Spayload, iCnt
   	if ((iCnt%iArgCnt)!=1) igoto skip
    iTmp StrayGetNum Spayload, iCnt
    iTmp = iTmp*10000/giTotalDur[iNo]
    Stmp sprintf ("%f"), iTmp
	skip:
 	Stmp strcat Stmp, " "
 	Sreturn strcat Sreturn, Stmp
 	iCnt += 1
 enduntil
 giReleaseDur[iNo] StrayGetNum Spayload, iLen-iArgCnt+1
 xout Sreturn
endop


; Everything coming from the midi device starts an instance of instr. 6
massign 0, 6
pgmassign 0, 6

instr	1
    ; Reposition some of the elements in the form.
	iCnt init 1
	iRow init 82
	iCol init 16
	chnset "visible(1)", "fqOffset_ident1"
	until iCnt > 8 do
		Sfq sprintfk "pos(%d, %d)", iCol, iRow
		Sam sprintfk "pos(%d, %d)", iCol+70, iRow
		Schn sprintfk "pos(%d, %d)", iCol+140, iRow+6
		Swf sprintfk "pos(%d, %d)", iCol+190, iRow+6
		Senv sprintfk "pos(%d, %d)", iCol+280, iRow+8
		SappEnv sprintfk "pos(%d, %d)", iCol+490, iRow+2
		
		SchnFq sprintfk "fq_ident%d", iCnt
		SchnAm sprintfk "am_ident%d", iCnt
		SchnChn sprintfk "chn_ident%d", iCnt
		SchnWf sprintfk "wf_ident%d", iCnt
		SchnEnv sprintfk "env_ident%d", iCnt
		SchnAppEnv sprintfk "applyEnv_ident%d", iCnt
		
		chnset Sfq, SchnFq
		chnset Sam, SchnAm
		chnset Schn, SchnChn
		chnset Swf, SchnWf
		chnset Senv, SchnEnv
		chnset SappEnv, SchnAppEnv
		
		iRow += 50
		iCnt=iCnt+1
		
	enduntil
	
    
; Call instr. 8 when we need to update the envelope.
#include "inc/changeTables.inc"

   ; allows users to toggle the type of display
   kChangeDisplay chnget "displaytype"
   if changed:k(kChangeDisplay)==1 then
      if kChangeDisplay==1 then
	    chnset "displaytype(\"spectrogram\")", "fft"
	  else
	    chnset "displaytype(\"spectroscope\")", "fft"
	  endif
   endif

	; Rec light
	gkRecStop chnget "btn1"
	if gkRecStop == 1 then
		chnset k(1), "recOn"
	else
		chnset k(0), "recOn"
	endif
	
    ; Rec button 
    if changed:k(gkRecStop) == 1 then
    	if gkRecStop == 0 then
    	   event "i", 102, 0, -1
	    else
			event "i",101, 0, -1
		endif
    endif
endin


instr 8
		Senv chnget sprintf("env%d", p4) ; Get string from the envelope texteditor
		iComp strcmp Senv, ""
		if iComp == 0 goto tOff ; If string is null, end
		istrlen    strlen   Senv ; Lenght of string
    	idelimiter strindex Senv, " " ; Position of first delimiter
    	S1    strsub Senv, 0, idelimiter ; Type of envelope
    	SenvPayload    strsub Senv, idelimiter + 1, istrlen ; Envelope
		if strcmp(S1, "t") == 0 then
			giTotalDur[p4] getTotalDur SenvPayload, 3
			SchangedEnv setPercentagesInString p4, SenvPayload, 3
			Sfenv sprintf "f %d 0 10000 -16 %s", p4+110, SchangedEnv ; transeg
		elseif strcmp(S1, "e") == 0 then	
			giTotalDur[p4] getTotalDur SenvPayload, 2
			SchangedEnv setPercentagesInString p4, SenvPayload, 2
			Sfenv sprintf "f %d 0 10000 -05 %s", p4+110, SchangedEnv ; exponseg
		else
			giTotalDur[p4] getTotalDur SenvPayload, 2
			SchangedEnv setPercentagesInString p4, SenvPayload, 2
			Sfenv sprintf "f %d 0 10000 -07 %s", p4+110, SchangedEnv ; linseg
		endif
		scoreline_i Sfenv ; Create table
		event "i", 9, 0, -1, p4
		turnoff
		tOff:
endin

instr 9
 	tablecopy 212, 110+p4 ; Copy the envelope into reusable table 212
	SmsgEn		sprintf	"tablenumber(%d)", 212	
	chnset	SmsgEn,"table1" ; Update the envelope graph

 	SwfNo		sprintf	"wf%d", p4
	iWf chnget SwfNo
	
	tablecopy 213, 20+iWf ; Copy the waveform into reusable table 213
	SmsgWf		sprintf	"tablenumber(%d)", 213	
	chnset	SmsgWf,"table2" ; Update the waveform graph

   	turnoff
endin

instr 2
	iCnt = 1
	iOffset chnget sprintf("fqOffset%d", p4) ; Get tuning offset
	until iCnt > 8 do		
		iFq chnget sprintfk("fq%d", iCnt) ; Get frequency
		iAmp chnget sprintfk("am%d", iCnt) ; Get amplitude
		if iAmp != 0 then
			event_i "i", 4, 0, 3600*24*7, iFq*(2^((p4-giKey)/12))*cent(iOffset), iAmp/100*p5, p4, iCnt
		endif
		iCnt += 1
	enduntil
	turnoff
 endin

instr 4
	
	if gkPlaying[p6] == 0 then
		turnoff
	endif

	if giTotalDur[p7] == giReleaseDur[p7] then ; Only one segment in the envelope
		kndx linseg 0, giTotalDur[p7], 1 ; Read the env. table from start to end in the specified amount of time
	else ; At least two segments in the envelope
		ib = int((giTotalDur[p7]-giReleaseDur[p7])/giTotalDur[p7]*100)/100 ; Position just before the release segment
		                                                                   ; in the envelope table
		kndx linsegr 0, giTotalDur[p7]-giReleaseDur[p7], ib, giReleaseDur[p7], 1 ; Read table from start to ib to end
	endif

	kEnvelope tablei kndx, 110+p7, 1 ; Read the envelope from the corresponding table.
	iWf chnget sprintf("wf%d", p7) ; Which waveform?
	asig poscil kEnvelope*p5, p4, 20+iWf  
	
	iChn chnget sprintf("chn%d", p7) ; Left, Right or Stereo?
	if iChn == 1 then
		gaL = gaL + asig
		gaR = gaR + asig
	elseif iChn == 2 then
		gaL += asig
	elseif iChn == 3 then
		gaR += asig
	endif    
endin

instr 5
 kLevel chnget "Level"

;Code taken from an example made by Iain McCurdy 
 /* PREVENT OVERLOADS */
 kRMS_L	rms gaL*kLevel				; scan rms
 kRMS_R	rms	gaR*kLevel				; scan rms
 kOn	=	1				; on value (needs to be a k-rate var.)
 kOff	=	0				; off value (needs to be a k-rate var.)
 kOverload	chnget	"Overload"		; read in value of 'Overload' LED
 if kRMS_L>0.4 || kRMS_R>0.4 then				; if rms exceeds a given value...
  chnset	kOn,"Overload"			; turn on 'Overload' LED
 endif
; ----------------------
 
 outs gaL*kLevel, gaR*kLevel ; Write to the audio channels
 dispfft (gaL+gaR)*kLevel*1.7, .1, 2048 ; FFT

 clear  gaL, gaR ; Set every sample of each of the given audio signals to zero when it is performed
endin

instr 6
	chnset "visible(0)", sprintfk("fqOffset_ident%d", gkLastKey) ; Make the last key tuning offset numberbox invisible
	ikey init 0						
	ivel init 0						
	midinoteonkey ikey, ivel
	chnset "visible(1)", sprintf("fqOffset_ident%d", ikey) ; Make the current key tuning offset visible
	if chnget:i("setTuning") == 1 then ; If the tuning button was in the 'waiting' state...
		Scc sprintf "text(%s%d,)", gSnotes[ikey%12], int(ikey/12-1) 
		chnset 0, "setTuning"; Release button
		chnset Scc, "setTuning_ident" ; Update button text. Eg.(C#4)
		giKey = ikey
		goto end ; no sound when setting the tuning
	endif
	iamp ampmidi 1
	gkPlaying[ikey] = 1 ; This note is currently on
	event_i "i", 2, 0, -1, ikey, iamp
	end:
	krel release
 	if krel==1 then ; activate the release part of the envelope.
			gkLastKey = ikey ; Last key pressed
			gkPlaying[ikey] = 0 ; Stop the sound!
			turnoff
	endif
	
endin

instr 101 ; Start recording
	aSigL,aSigR   monitor
	iDate date
	Sfile sprintfk "../Recordings/RT_%d.wav", iDate
	fout     Sfile,4,aSigL,aSigR   
endin

instr 102 ; Stop Recording
	turnoff2 101, 0, 0.1
	turnoff
endin

</CsInstruments>

<CsScore>

f21 0 16383 10 1                                          ; Table with a Sine wave
f25 0 16383 10 1 1   1   1    0.7 0.5   0.3  0.1          ; Table with a Pulse

i 1 0 [3600*24*7]
i 5 0 [3600*24*7]
</CsScore>

</CsoundSynthesizer>
